//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <dos.h>
#include <string.h>
#include <registry.hpp>
#include <mmsystem.h>
#include <shellapi.h>
#pragma hdrstop

#include "fCPMain.h"
#include "AboutBox.h"
#include "fHighScore.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmCPMain *frmCPMain;

bool isPlayMode;
bool isGameOver;
int countDown;
long tickStart;
long tickTotal;
int challengeCount;
bool isEndWithRegDelete;
const char regTitle[] = "ClickPenguin";

AnsiString exePath;   // path of exefile's directory.


#define TRYNUM 10

int eachtime[TRYNUM];


//---------------------------------------------------------------------------
__fastcall TfrmCPMain::TfrmCPMain(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmCPMain::FormCreate(TObject *Sender)
{
    randomize();
    int i,j;
    isEndWithRegDelete = false;

    
     exePath = ExtractFilePath(Application->ExeName);


    /*   *****      WXgݒǂݍ             */

    TRegIniFile *ini = new TRegIniFile("Software\\TF Software");

    // pX[h
    AnsiString pas;

    for (i = 0; i < 3; i++) {

        for (j = 0; j < 5; j++) {

    	    high[i][j] = new shighScore;
        }

    }


    // ̑ݒǂݍ

    //eraseMode = (short)ini->ReadInteger(regTitle,"EraseMode",0);
    //diff1P = (short)ini->ReadInteger(regTitle,"Diff1P",1);
    isSoundEnabled = ini->ReadBool(regTitle,"Sound",true);
    difficulty = ini->ReadInteger(regTitle,"LastDifficulty",0);


    // OK

    AnsiString as; //
    as = regTitle;
    for (i = 0; i < 3; i++) {
        for (j = 0; j < 5; j++) {
            high[i][j]->time = ini->ReadInteger(as+"\\HighScore"+IntToStr(i+1),"Time"+IntToStr(j+1),(10000+j*2000));
            high[i][j]->name = ini->ReadString(as+"\\HighScore"+IntToStr(i+1),"Name"+IntToStr(j+1),"Pentan");
            high[i][j]->score = ini->ReadInteger(as+"\\HighScore"+IntToStr(i+1),"Score"+IntToStr(j+1),60-(j*5));
        }
    }


    delete ini;
    //  WXgǂݍݏI


    mnuOptionSound->Checked = isSoundEnabled;

    mnuLevelSelect(NULL);

}
//---------------------------------------------------------------------------

void __fastcall TfrmCPMain::FormDestroy(TObject *Sender)
{
    int i,j;


    // WXg
    TRegIniFile *ini = new TRegIniFile("Software\\TF Software");
   // AnsiString as;
   // as = regTitle;

   // Application->MessageBox(as.c_str(),"WXg̍폜", MB_ICONINFORMATION);


    if (isEndWithRegDelete == true) {


            //ini->DeleteKey(regTitle, "special");
            ini->EraseSection(regTitle);
            Application->MessageBox("WXg폜܂B",
            "WXg̍폜", MB_ICONINFORMATION);




    } else {



      ini->WriteInteger(regTitle,"LastDifficulty",difficulty);
  //    ini->WriteInteger(regTitle,"Diff1P",(long)diff1P);
      ini->WriteBool(regTitle,"Sound",isSoundEnabled);
  //    ini->WriteInteger(regTitle,"ItemIntervalSingle",itemInterSingle);

      for (i = 0; i < 3; i++) {
          for (j = 0; j < 5; j++) {
              ini->WriteInteger((AnsiString)regTitle+"\\HighScore"+IntToStr(i+1),"Time"+IntToStr(j+1),high[i][j]->time);
              ini->WriteString((AnsiString)regTitle+"\\HighScore"+IntToStr(i+1),"Name"+IntToStr(j+1),high[i][j]->name);
              ini->WriteInteger((AnsiString)regTitle+"\\HighScore"+IntToStr(i+1),"Score"+IntToStr(j+1),high[i][j]->score);
          }
      }

    }


    delete ini;


    for (i = 0; i < 3; i++) {
        for (j = 0; j < 5; j++) {
    	    delete high[i][j];
        }
    }

}
//---------------------------------------------------------------------------


void __fastcall TfrmCPMain::mnuExitClick(TObject *Sender)
{

    GetAsyncKeyState('Z'); // obt@ zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz


    if (GetAsyncKeyState('Z')) {
        if (Application->MessageBox("ACXg[̂߂ɂ̃\tg\nWXg폜܂?",
            "WXg̍폜",MB_YESNO | MB_ICONINFORMATION) == IDYES) {
            isEndWithRegDelete = true;

        }
        else {
            return;
        }

    }


    Close();
        
}
//---------------------------------------------------------------------------
void __fastcall TfrmCPMain::imgClickableMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        long tickTime;

        tickTime = GetTickCount(); // ܂Ԃ擾Ă


// NbNƂ
     if (isPlayMode) {

        tickTime = tickTime - tickStart;
        playSound("ID_WAVECLICK");
    //    ShowMessage("Time: " + IntToStr(tickTime) + "ms");

        imgClickable->Visible = false;

        eachtime[challengeCount-1] = tickTime;
        tickTotal += tickTime;

        challengeCount++;


        StatusBar->Panels->Items[1]->Text = "Last: " + IntToStr(tickTime)+ "ms";
        StatusBar->Panels->Items[2]->Text = "Total: " + IntToStr(tickTotal)+ "ms";



        if (challengeCount > TRYNUM) {

            isGameOver = true;
            isPlayMode = false;
            countDown = 0;
            tmrMain->Enabled = false;
            StatusBar->Panels->Items[0]->Text = "I";
            mnuLevel->Enabled = true;
            

            // o[W

            int score;
            score = getScore(eachtime,TRYNUM);

            AnsiString as;
            as ="̃^C:" + IntToStr(tickTotal) + "ms\n" + "XRA : " + IntToStr(score)+ "_";




            Application->MessageBox(as.c_str(),"XRA", MB_ICONINFORMATION | MB_OK);

            checkBestTime(tickTotal,score);


            btnStart->Visible = true;
            lblCountDown->Caption= "Click the Penguin!";
        }
        else {
            countDown = 4;
            tmrMain->Enabled = true;

            StatusBar->Panels->Items[0]->Text = "Challenge: " + IntToStr(challengeCount);

        //    StatusBar->Panels->Items[1]->Text = "Last: " + IntToStr(tickTime)+ "ms";
        //    StatusBar->Panels->Items[2]->Text = "Total: " + IntToStr(tickTotal)+ "ms";

        }
      //  StatusBar.Panels[1]->Text = "Last: " + FloatToStr(tickTime / 1000.0);


     }




}
//---------------------------------------------------------------------------
// XRAZo
int TfrmCPMain::getScore(int *times,const int count) {

    const int standardtime = 600;
    int substractpoint;   // _
    int i;
    int eachsubst;

    substractpoint = 0;


    for (i = 0; i < count; i++) {

        eachsubst = times[i] - standardtime;
        if (eachsubst <0) eachsubst = 0;

        eachsubst = eachsubst/50;
        if (eachsubst > (100/count)) eachsubst = 100/count;

        substractpoint += eachsubst;


    }

    return (100-substractpoint);




}

//---------------------------------------------------------------------------

// nCXRÃ`FbN
void TfrmCPMain::checkBestTime(const int cleartime, const int score) {

        int i;
        int rank = 0,work;

        for (i=5;i>=1;i--) {

            if ( cleartime < high[difficulty][i-1]->time ) {

                work = high[difficulty][i-1]->time;
                high[difficulty][i-1]->time = cleartime;

                if (i != 5 ) high[difficulty][i]->time = work;

                work = high[difficulty][i-1]->score;
                high[difficulty][i-1]->score = score;

                if (i != 5 ) {
                    high[difficulty][i]->score = work;
                    high[difficulty][i]->name = high[difficulty][i-1]->name;
                }
                rank = i;
            }
            else {
                break;
            }
        }

        if ( rank > 0 ) {  //Tʈȓ

            frmHighScore = new TfrmHighScore(this);

            frmHighScore->Edit1->Visible = true;
            frmHighScore->Edit1->Top = frmHighScore->lblName[rank]->Top;
            frmHighScore->Edit1->Left = frmHighScore->lblName[rank]->Left;
            frmHighScore->lblName[rank]->Visible = false;
            frmHighScore->Edit1->BringToFront();

            frmHighScore->ShowModal();

            high[difficulty][rank-1]->name = frmHighScore->Edit1->Text;

            delete frmHighScore;

        }



}




//---------------------------------------------------------------------------
void __fastcall TfrmCPMain::mnuStartClick(TObject *Sender)
{

  //  if (isPlayMode == false) {

        isPlayMode = true;
        tmrMain->Enabled = true;
        countDown = 4;
        btnStart->Visible = false;
        challengeCount = 1;
        tickTotal = 0;
        tmrMainTimer(NULL);
        isGameOver = false;
        imgClickable->Visible = false;
        mnuLevel->Enabled = false;


        
        StatusBar->Panels->Items[0]->Text = "Challenge: " + IntToStr(challengeCount);
        
        StatusBar->Panels->Items[1]->Text = "";
        StatusBar->Panels->Items[2]->Text = "";


  //  }



}
//---------------------------------------------------------------------------
void __fastcall TfrmCPMain::tmrMainTimer(TObject *Sender)
{
    if (countDown > 0) {
        countDown--;
        lblCountDown->Caption = IntToStr(countDown);
        
        if (countDown != 0) {
           playSound("ID_WAVEREADY");
        }
        else {
           playSound("ID_WAVESET");
        }
    }

    if (countDown == 0) {

        imgClickable->Visible = true;

        imgClickable->Left = (rand() % (ClientWidth - 32));
        imgClickable->Top = (rand() % (ClientHeight - 32 - StatusBar->Height));
        countDown--;
        tickStart = GetTickCount();
        tmrMain->Enabled = false;
    }



}
//---------------------------------------------------------------------------

void __fastcall TfrmCPMain::btnStartClick(TObject *Sender)
{
    mnuStartClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TfrmCPMain::FormResize(TObject *Sender)
{

    lblCountDown->Left = (this->ClientWidth-lblCountDown->Width)/2;
    lblCountDown->Top = (this->ClientHeight- lblCountDown->Height)/2;

    
    btnStart->Left = (this->ClientWidth-btnStart->Width) /2;
    btnStart->Top = (lblCountDown->Top + lblCountDown->Height +10);


}
//---------------------------------------------------------------------------


void __fastcall TfrmCPMain::mnuLevelSelect(TObject *Sender)
{

    int levelsizes[][2] = { {400, 300},
                            {600, 450},
                            {750, 550},

                          };

    TMenuItem *mnuLev[] = { mnuLevelEasy, mnuLevelNormal, mnuLevelDifficult };



    if (Sender != NULL) {
      difficulty = ((TMenuItem *)Sender)->Tag;
    }

    mnuLev[difficulty]->Checked = true;

    Visible = false;
    ClientWidth = levelsizes[difficulty][0];
    ClientHeight = levelsizes[difficulty][1];
    Left = (Screen->Width-Width)/2;
    Top = (Screen->Height- Height)/2;


    Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmCPMain::About1Click(TObject *Sender)
{
    // o[W
    //Application->MessageBox("ClickPenguin\nPresented by TF","About ClickPenguin", MB_ICONINFORMATION | MB_OK);
    frmAbout->title = "Click the Penguin Ver. 1.00";
    frmAbout->ShowModal();

}
//---------------------------------------------------------------------------

void __fastcall TfrmCPMain::mnuHighScoreClick(TObject *Sender)
{
    char chlevel[][10] = { "()","()","(㋉)" };
    char chrtitle[20];

    strcpy(chrtitle,"BestTime");
    strcat(chrtitle,chlevel[difficulty]);

    frmHighScore = new TfrmHighScore(this);
    frmHighScore->Caption = chrtitle;
    frmHighScore->ShowModal();
    delete frmHighScore;

}
//---------------------------------------------------------------------------

/*
    // EXE ̃pX߂ ֐ (ExtractFilePath sgp)
    int i;

    int num;
    num = _argc;
    int lastslashpoint;  // Ō̃pX \ ̈ʒu


  //  char *pt,*lastptr;
    char exename[255];

    strcpy(exename, _argv[0]);


 //   i = 0;

    for (i=0;exename[i] !='\0'; i++) {

        if (exename[i] == '\\') {
            lastslashpoint = i;
            ShowMessage(i);
        }
    }

    exename[lastslashpoint +1] = '\0';
    ShowMessage(exename);

    ShowMessage(lastslashpoint);

    for (i = 0; i< _argc; i++) {

        ShowMessage(_argv[i]);

   }

    ShowMessage(num);
 */

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TfrmCPMain::mnuOptionSoundClick(TObject *Sender)
{

    mnuOptionSound->Checked = !(mnuOptionSound->Checked);
    isSoundEnabled = mnuOptionSound->Checked;


}
//---------------------------------------------------------------------------

void __fastcall TfrmCPMain::Readme1Click(TObject *Sender)
{
    AnsiString fileReadme;

    fileReadme = exePath + "ClickPen.txt";

    ShellExecute( Handle, "open",fileReadme.c_str(), NULL, exePath.c_str(), SW_MAXIMIZE);
}
//---------------------------------------------------------------------------
void TfrmCPMain::playSound(const AnsiString sndName)
{
    if (isSoundEnabled == false) return;

    PlaySound(sndName.c_str(),HInstance,SND_ASYNC | SND_NODEFAULT |SND_RESOURCE);

}
